program WEcho; {Displays its parameters in a message box.}

{$APPTYPE GUI}
uses Strings,Windows;
const
   c = '(C) Dancs Andrs, 2001. FreeWare.';
var
   ms : string;
   msc : PChar;
   i,n : integer;

{****************************************************************************}

function GetParmCount : integer;
{-1 : error; 0 : executable; 1... parameters on command line}
var
   s : string;
   i,ip1,n : integer;
   quoted,white : Boolean;
begin
s:=StrPas(CmdLine);
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if not quoted then begin
      ip1:=ip1+1; {new parameter}
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then white:=false
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   end
  else white:=false;
GetParmCount:=ip1;
end;

{****************************************************************************}

function GetParm(ip : integer) : string;
var
   s,ps : string;
   i,ip1,n : integer;
   fc : array[0..64,1..2] of integer;
   quoted,white : Boolean;
begin
ps:=''; 
s:=StrPas(CmdLine);
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if quoted then fc[ip1,2]:=i else begin
      ip1:=ip1+1; {new parameter}
      fc[ip1,1]:=i;
      fc[ip1,2]:=i;
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then begin
   white:=false; fc[ip1,2]:=i;
   end
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   fc[ip1,1]:=i;
   fc[ip1,2]:=i;
   end
  else begin
   white:=false;
   fc[ip1,2]:=i;
   end;
if ip<=ip1 then ps:=Copy(s,fc[ip,1],fc[ip,2]-fc[ip,1]+1);  
GetParm:=ps;
end;

{****************************************************************************}

begin
ms:='';
n:=GetParmCount;
if n>0 then for i:=1 to n do begin
   ms:=ms+GetParm(i);
   if i<n then ms:=ms+' ';
   end;
GetMem(msc,256);
StrPCopy(msc,ms);
i:=MessageBox(0,msc,'Message',MB_OK);
FreeMem(msc,256);
end.